/*
 * Copyright (C) 2015-2021 IoT.bzh Company
 * Author "Fulup Ar Foll"
 *
 * $RP_BEGIN_LICENSE$
 * Commercial License Usage
 *  Licensees holding valid commercial IoT.bzh licenses may use this file in
 *  accordance with the commercial license agreement provided with the
 *  Software or, alternatively, in accordance with the terms contained in
 *  a written agreement between you and The IoT.bzh Company. For licensing terms
 *  and conditions see https://www.iot.bzh/terms-conditions. For further
 *  information use the contact form at https://www.iot.bzh/contact.
 *
 * GNU General Public License Usage
 *  Alternatively, this file may be used under the terms of the GNU General
 *  Public license version 3. This license is as published by the Free Software
 *  Foundation and appearing in the file LICENSE.GPLv3 included in the packaging
 *  of this file. Please review the following information to ensure the GNU
 *  General Public License requirements will be met
 *  https://www.gnu.org/licenses/gpl-3.0.html.
 * $RP_END_LICENSE$
*/

#pragma once

#include "oidc-idp.h"

#define IDP_CLIENT_SECRET_DEFAULT IDP_CLIENT_SECRET_POST
// #define IDP_RESPOND_TYPE_DEFAULT IDP_RESPOND_TYPE_CODE
#define IDP_RESPOND_TYPE_DEFAULT IDP_RESPOND_TYPE_CODE

typedef struct {
    const char *fedid;
    const char *pseudo;
    const char *avatar;
    const char *name;
    const char *company;
    const char *email;
    const char *attrs;
    const char *idpsid;
    char *auth64;
    json_object *jwksJ;
} oidcSchemaT;

// oidc.c
int oidcRegisterAlias (oidcIdpT * idp, afb_hsrv * hsrv);
int oidcRegisterConfig (oidcIdpT * idp, json_object * idpJ);
